/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    h8_3694.h : H8/3694F `t@C                           ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
/**** WX^}N ****/
#define	stopirq()	asm("	orc	#128, ccr")
#define startirq()	asm("	andc	#127, ccr")

/************************************************************************
 *    }bv                                                      *
 ************************************************************************/
#define	VECTOR_ADD	(0x0000)
#define	VECTOR_SIZE	(0x0034)
#define	FLASH_ADD	(0x0034)
#define FLASH_END	(0x7fff)
#define FLASH_SIZE	(0x8000 - 0x0034)

#define RAM_ADD		(0xf780)
#define	RAM_END		(0xff80)
#define RAM_SIZE	(0x0800)

/************************************************************************
 *    W[WX^`                                        *
 ************************************************************************/
/**** 荞݃Rg[ ****/
#define	IEGR1	*((unsigned char *)0xFFF2)	/* IRQ GbWI 1 */
#define	IEGR2	*((unsigned char *)0xFFF3)	/* IRQ GbWI 2 */
#define	IENR1	*((unsigned char *)0xFFF4)	/* IRQ Cl[u */
#define	IRR1	*((unsigned char *)0xFFF6)	/* IRQ tO */
#define	IWPR	*((unsigned char *)0xFFF8)	/* WakeUp 荞݃tO */

/**** AhXu[NRg[ ****/
#define	ABRKCR	*((unsigned char *)0xFFC8)	/* Address Break Control */
#define	ABRKSR	*((unsigned char *)0xFFC9)	/* Address Break Status */
#define	BARH	*((unsigned char *)0xFFCA)	/* Break Address H */
#define	BARL	*((unsigned char *)0xFFCB)	/* Break Address L */
#define	BDRH	*((unsigned char *)0xFFCC)	/* Break Data H */
#define	BDRL	*((unsigned char *)0xFFCD)	/* Break Data L */

/**** d́EX^oCRg[ ****/
#define	MSTCR1	*((unsigned char *)0xFFF9)	/* Module Stanby Control */
#define	SYSCR1	*((unsigned char *)0xFFF0)	/* System Control 1 */
#define	SYSCR2	*((unsigned char *)0xFFF1)	/* System Control 2 */

/**** tbV ****/
#define	FLMCR1	*((unsigned char *)0xFF90)	/* Flash Memory control 1 */
#define	FLMCR2	*((unsigned char *)0xFF91)	/* Flash Memory control 2 */
#define	FLPWCR	*((unsigned char *)0xFF92)	/* Flash Power control */
#define	EBR1	*((unsigned char *)0xFF93)	/* ubNw背WX^ 1 */
#define	FENR	*((unsigned char *)0xFF9B)	/* Flash Enable */

/**** I/O|[g ****/
#define	PUCR1	*((unsigned char *)0xFFD0)	/* |[gvAbv 1 */
#define	PUCR5	*((unsigned char *)0xFFD1)	/* |[gvAbv 5 */
#define	PDR1	*((unsigned char *)0xFFD4)	/* |[gf[^ 1 */
#define	PDR2	*((unsigned char *)0xFFD5)	/* |[gf[^ 2 */
#define	PDR5	*((unsigned char *)0xFFD8)	/* |[gf[^ 5 */
#define PDR5_AD (0xFFD8)			/* |[gf[^ 5 AhX */
#define	PDR7	*((unsigned char *)0xFFDA)	/* |[gf[^ 7 */
#define	PDR8	*((unsigned char *)0xFFDB)	/* |[gf[^ 8 */
#define	PDRB	*((unsigned char *)0xFFDD)	/* |[gf[^ B */

#define	PMR1	*((unsigned char *)0xFFE0)	/* |[g[hWX^ 5 */
#define	PMR5	*((unsigned char *)0xFFE1)	/* |[g[hWX^ 1 */
#define	PCR1	*((unsigned char *)0xFFE4)	/* |[gRg[ 1 */
#define PCUR1	*((unsigned char *)0xFFD0)	/* |[gvAbv 1 */
#define	PCR2	*((unsigned char *)0xFFE5)	/* |[gRg[ 2 */
#define	PCR5	*((unsigned char *)0xFFE8)	/* |[gRg[ 5 */
#define PCUR5	*((unsigned char *)0xFFD1)	/* |[gvAbv 5 */
#define	PCR7	*((unsigned char *)0xFFEA)	/* |[gRg[ 7 */
#define	PCR8	*((unsigned char *)0xFFEB)	/* |[gRg[ 8 */

/**** ^C}A ****/
#define	TMA	*((unsigned char *)0xFFA6)	/* ^C}[h A */
#define	TCA	*((unsigned char *)0xFFA7)	/* ^C}JE^ A */

/**** ^C}V ****/
#define	TCRV0	*((unsigned char *)0xFFA0)	/* ^C}Rg[ V0 */
#define	TCSRV	*((unsigned char *)0xFFA1)	/* Rg[/Xe[^X V */
#define	TCORA	*((unsigned char *)0xFFA2)	/* ^CRX^g A */
#define	TCORB	*((unsigned char *)0xFFA3)	/* ^CRX^g B */
#define	TCNTV	*((unsigned char *)0xFFA4)	/* ^C}JE^ V */
#define	TCRV1	*((unsigned char *)0xFFA5)	/* ^C}Rg[ V1 */

/**** ^C}W ****/
#define	TMRW	*((unsigned char *)0xFF80)	/* ^C}[h W */
#define	TCRW	*((unsigned char *)0xFF81)	/* ^C}Rg[ W */
#define	TIERW   *((unsigned char *)0xFF82)	/* ^C}Interrupt Enable W */
#define	TSRW	*((unsigned char *)0xFF83)	/* ^C}Xe[^X W */
#define	TIOR0	*((unsigned char *)0xFF84)	/* ^C}IORg[0 */
#define	TIOR1	*((unsigned char *)0xFF85)	/* ^C}IORg[1 */
#define	TCNT	*((unsigned int  *)0xFF86)	/* ^C}JE^ */
#define	GRA	*((unsigned int  *)0xFF88)	/* WFlWX^ A */
#define	GRB	*((unsigned int  *)0xFF8A)	/* WFlWX^ B */
#define	GRC	*((unsigned int  *)0xFF8C)	/* WFlWX^ C */
#define	GRD	*((unsigned int  *)0xFF8E)	/* WFlWX^ D */

/**** EHb`hbO^C} ****/
#define	TCSRWD	*((unsigned char *)0xFFC0)	/* ^C}Rg[ WD */
#define	TCWD	*((unsigned char *)0xFFC1)	/* ^C}JE^ WD */
#define	TMWD	*((unsigned char *)0xFFC2)	/* ^C}[h WD */

/**** VAR~jP[VC^[tF[X ****/
#define	SMR	*((unsigned char *)0xFFA8)	/* VA[hWX^ */
#define	BRR	*((unsigned char *)0xFFA9)	/* rbg[gWX^ */
#define	SCR3	*((unsigned char *)0xFFAA)	/* VARg[ 3 */
#define	TDR	*((unsigned char *)0xFFAB)	/* Mf[^WX^ */
#define	SSR	*((unsigned char *)0xFFAC)	/* VAXe[^X */
#define	RDR	*((unsigned char *)0xFFAD)	/* Mf[^WX^ */

/**** IICoXC^[tF[X ****/
#define	ICCR1	*((unsigned char *)0xF748)	/* IICoXRg[1 */
#define	ICCR2	*((unsigned char *)0xF749)	/* IICoXRg[2 */
#define	ICMR	*((unsigned char *)0xF74A)	/* IICoX[hWX^ */
#define	ICIER	*((unsigned char *)0xF74B)	/* IICoXInterrupt Enable */
#define	ICSR	*((unsigned char *)0xF74C)	/* IICoXXe[^X */
#define	SAR	*((unsigned char *)0xF74D)	/* X[uAhX */
#define	ICDRT	*((unsigned char *)0xF74E)	/* IICoXMf[^ */
#define	ICDRR	*((unsigned char *)0xF74F)	/* IICoXMf[^ */

/**** ADϊ ****/
#define	ADDRA	*((unsigned int  *)0xFFB0)	/* ADf[^WX^ A */
#define	ADDRB	*((unsigned int  *)0xFFB2)	/* ADf[^WX^ B */
#define	ADDRC	*((unsigned int  *)0xFFB4)	/* ADf[^WX^ C */
#define	ADDRD	*((unsigned int  *)0xFFB6)	/* ADf[^WX^ D */
#define	ADCSR	*((unsigned char *)0xFFB8)	/* ADRg[/Xe[^X */
#define	ADCR	*((unsigned char *)0xFFB9)	/* ADRg[ */

/**** doHiIvVj ****/
#define	LVDCR	*((unsigned char *)0xF730)	/* doRg[ */
#define	LVDSR	*((unsigned char *)0xF731)	/* dXe[^X */

/**** EEPROM(H8/3694N̂) ****/
#define	EKR	*((unsigned char *)0xFF10)	/* EPROM Key Register */

/* end of file */


