;	GCC For the Hitachi H8/300
;	By Hitachi America Ltd and Cygnus Support
;	release F-1
;
;;;----------------------------------------------------------------------
;;; RAM$B>e$K%3%T!<$7$FF0:n$5$;!"(BRAM$B>e$N%G!<%?$OGK2u$9$k!#(B
;;; $B%b%8%e!<%k3+;OA0$OA4$F$N<~JUF0:n$rDd;_$7!"%b%8%e!<%k=*N;8e$O%j%;%C%H(B
;;; $B%Y%/%?$KHt$V!#(B
;;; $B%W%m%0%i%`$rJQ99$7$?>l9g$O%"%I%l%9$,JQ2=$9$k>l9g$,$"$k$N$GCm0U$9$k$3$H!#(B
;;; $B%W%m%0%i%`$OA4$F(BPC$BAjBP7O$NL?Na$r;HMQ$7!"%8%c%s%W7O$NL?Na$O;HMQ$7$J$$$3$H!#(B
;;; $B;HMQ$9$k(BRAM$BNN0h(B
;;;   _sdata = $B=q$-9~$_%G!<%?(B(128Byte) ..... 0xf780 (sysParam$B9=B$BN$=$N$^$^!K(B
;;;   _rdata = $B:F=q$-9~$_%G!<%?(B(128Byte) ... 0xf800
;;;   _adata = $BDI2C=q9~$_%G!<%?(B(128Byte) ... 0xf880
;;;   _vfy_m = verify $B%U%i%C%0(B m ........... 0xf900
;;;   $B%W%m%0%i%`%"%I%l%9(B ................... 0xf904$B!A(B
;;;     _eraseParam ........................ 0x080a-0x0800+0xf900=0xf90a
;;;     _saveparam ......................... 0x08e0-0x0800+0xf900=0xf9e0


	.h8300h
	.file	"progsysp.s"
	.section .ptext
	.align 2
	.global _vfy_m
_vfy_m:		.long	0
	.global _execErase
_execErase:
	jmp	@0xf90c

	.global _execWrite
_execWrite:
	jmp	@0xf9e6

;;;----------------------------------------------------------------------
;;; $B>C5n4X?t(B
;;;----------------------------------------------------------------------
	.align	2
	.global	_eraseParam
_eraseParam:
	push.l	er6
	mov.l	er7,er6
	push.l	er5
	push.l	er2
	push.l	er1

	bset.b	#6, @0xff90:8	; SWE bit = 1
	mov.w	#2, r0
	bsr	_asmWaitusec:16	; 1usec$BBT5!(B
	bset.b	#1, @0xff93:8	; EBR1$B$N(Bbit1$B%;%C%H(B($B>C5n%(%j%"A*Br(B)
	sub.w	r5, r5		; r5 = n
.ESTART:	
	bset.b	#5, @0xff90:8	; ESU bit = 1
	mov.w	#200, r0
	bsr	_asmWaitusec:16	; 100usec $BBT5!(B
	bset.b	#1, @0xff90:8	; E bit = 1 $B>C5n3+;O(B
	mov.w	#20000, r0
	bsr	_asmWaitusec:16	; 10msec $BBT5!(B
	bclr	#1, @0xff90:8	; E bit = 0 $B>C5n=*N;(B
	mov.w	#20, r0
	bsr	_asmWaitusec:16	; 10usec $BBT5!(B
	bclr	#5, @0xff90:8	; ESBU bit = 0
	mov.w	#20, r0
	bsr	_asmWaitusec:16	; 10usec $BBT5!(B
	bset	#3, @0xff90:8	; EV bit = 1
	mov.w	#40, r0
	bsr	_asmWaitusec:16	; 20usec $BBT5!(B
	sub.w	r1, r1		; r1 = 0
	mov.b	#0x04, r1h	; r1 = 0x0400
	extu	er1		; er1 = flash$B@hF,%"%I%l%9(B
.EVERIFY:
	mov.b	#0xff, r0l
	mov.b	r0l, @er1	; 0xff $B$r%@%_!<%i%$%H(B
	mov.w	#4, r0
.ELOOP1:			; 2usec $BBT5!(B
	nop			; 2$B%9%F!<%H(B
	sub.w	#1, r0		; 4$B%9%F!<%H(B
	bne	.ELOOP1		; 4$B%9%F!<%H(B
	mov.l	@er1, er2	; $B%G!<%?FI$_$@$7(B
	cmp.l	#0xffffffff, er2
	beq	.VOK
	bclr	#3, @0xff90:8	; EV bit $B%/%j%"(B
	mov.w	#8, r0
	bsr	_asmWaitusec:16	; 4usec $BBT5!(B
	add.w	#1, r5
	cmp.w	#100, r5
	blt	.ESTART		; $B:F>C5n(B
	mov.w	#-1, r5		; $BLa$jCM%;%C%H(B
	bra	.EEND		; $B:G=*=hM}$XHt$V(B
.VOK:
	add.l	#4, er1		; $B%"%I%l%9%$%s%/%j%a%s%H(B
	cmp.l	#0x0800, er1	; $B=*N;Hf3S(B
	blt	.EVERIFY
	bclr	#3, @0xff90:8	; EV bit $B%/%j%"(B
	mov.w	#8, r0
	bsr	_asmWaitusec:16	; 4usec $BBT5!(B
	mov.w	#1, r5		; $BLa$jCM%;%C%H(B
.EEND:	
	bclr.b	#6, @0xff90:8	; SWE bit $B%/%j%"(B
	mov.w	#200, r0
	bsr	_asmWaitusec:16	; 100usec$BBT5!(B
	mov.w	r5, r0		; $BLa$jCM%;%C%H(B

	mov.w	#20000, r0
	bsr	_asmWaitusec:16	; 10msec $BBT5!(B
	mov.l	#0x0400, er0	; Flash $B=q$-9~$_%"%I%l%9%;%C%H(B
	bra	_saveParam

;;;----------------------------------------------------------------------
;;; $B%7%9%F%`JQ?t=q$-9~$_4X?t(B
;;;----------------------------------------------------------------------
;;; $B;HMQ%l%8%9%?!'(Ber0, er1, er4, er5
;;; $B$3$N4X?t$N:G8e$OI,$:%j%V!<%H$G$b$I$i$J$$!#$7$?$,$C$F!"(BSP,FP$B$NBTHr!"(B
;;; $B%l%8%9%?$NBTHr$O9T$o$J$$!#(B
	.global _saveParam
_saveParam:
	mov.l	er0, er1	; Flash $B=q$-9~$_%"%I%l%9(B
	bset.b	#6, @0xff90:8	; SWE bit = 1
	mov.w	#2, r0
	bsr	_asmWaitusec:16	; 1usec$BBT5!(B
	
	;; rdata[i] <- sdata[i] (128Byte$BJ,(B)
	mov.b	#128, r4l	; $BO"B3E>Aw%5%$%:(B
	mov.l	#0xf780,er5	; sdata address ($BE>Aw85(B)
	mov.l	#0xf800,er6	; rdata address ($BE>Aw@h(B)
	eepmov.b		; $B<+F0O"B3E>Aw(B

	;; 128Byte$B=q$-9~$_(B($B%j%H%i%$(B1000$B2s(B)
	sub.w	r0, r0		; r0(n) = 0, er1$B$O(BFlash$B=q$-9~$_%"%I%l%9(B
.L10:	
	bsr	@_writeSysData:16
	mov.w	@0xf900, r2	; _vfy_m $B$NFbMF$rFI$_9~$_(B
	beq	.L9		; if (vfy_m == 0) end program
	add.w	#1, r0		; n++;
	cmp.w	#999, r0	; if (n < 1000)
	ble	.L10		; jump .L10
.L9:
	bclr.b	#6, @0xff90:8	; SWE bit clear
	mov.w	#200,r0
	bsr	_asmWaitusec:16
	
	;; $B:F5/F0(B
	jmp	@_start

.MUGEN:
	jmp	@.MUGEN

;;;----------------------------------------------------------------------
;;; $BFbB"%U%i%C%7%e%a%b%j$X$N%G!<%?=q$-9~$_(B
;;;----------------------------------------------------------------------
	.align 2
	.global _writeSysData
_writeSysData:
	push.l	er6
	mov.l	er7,er6
	sub	#12,sp
	push.l	er4
	push.l	er5
	push.l	er1
	push.l	er0

	mov.w	r0,@(-2,er6)	; r0 = n
	mov.l	er1,@(-8,er6)	; r1 = Flash address

	;; $B%U%i%C%7%e%a%b%j$X$NO"B3E>Aw(B
	mov.b	#128, r4l
	mov.l	er6, er3	; er6$BBTHr(B
	mov.l	#0xf800, er5	; er5 = $B:F=q$-9~$_%G!<%?(B
	mov.l	er1, er6	; er6 = $B%U%i%C%7%e%a%b%j%"%I%l%9(B
	eepmov.b		; 128byte $BO"B3E>Aw(B
	mov.l	er3, er6	; er6$BI|5"(B

	;; $B=q$-9~$_%Q%k%90u2C(B
	cmp.w	#5, r0
	bgt	.L27
	mov.b	#30, r0l
	bra	.L28
.L27:
	mov.b	#200,r0l
.L28:
	bsr	@_writePulse:16

	;; Verify
	bset	#2, @0xff90:8	; PVbit = 1
	mov.w	#8,r0
	bsr	_asmWaitusec:16
	
	;; rdata[i] <- sdata[i] (128Byte$BJ,(B)
	sub.w	r5, r5		; i = 0
	mov.w	r5, @0xf900	; (m = 0) _vfy_m$B%/%j%"(B
.L30:
	mov.l	@(-8,er6), er1	; er1 = $B%U%i%C%7%e%a%b%j%"%I%l%9(B
	extu	er5		; $B%5%$%:3HD%(B
	add.l	er5, er1	; er1 = &fdata[i]
	mov.b	#0xff, r0l
	mov.b	r0l, @er1	; fdata[i] = 0xff($B%@%_!<%i%$%H(B)

	mov.w	#4, r0
.LOOP4:				; 2usec$BBT5!(B
	nop			; 2$B%9%F!<%H(B
	sub.w	#1, r0		; 4$B%9%F!<%H(B
	bne	.LOOP4		; 4$B%9%F!<%H(B

	mov.l	#0xf780, er4	; er4 = &sdata[0]
	add.l	er5, er4	; er4 = &sdata[i]
	mov.l	@er4, er3	; er3 = sdata[i]  $B85%G!<%?(B
	mov.l	@er1, er2	; er2 = fdata[i]  $B%Y%j%U%!%$%G!<%?(B
	cmp.l	er2, er3	; $BHf3S(B
	beq	.L32		; $B0lCW!)(B
	mov.w	#1, r0
	mov.w	r0, @0xf900	; _vfy_m = 1
.L32:
	;; $BDI2C=q9~$_%G!<%?1i;;(B
	mov.l	#0xf800, er0	; er0 = &rdata[0]
	add.l	er5, er0	; er0 = &rdata[i]
	mov.l	@er0, er1	; er2=verify data, er1=retry data
	or.l	er2, er1	; er1=$BDI2C=q9~$_%G!<%?1i;;7k2L(B
	mov.l	#0xf880, er4	; er4 = &adata[0]
	add.l	er5, er4	; er4 = &adata[i]
	mov.l	er1, @er4	; $BDI2C=q9~$_%G!<%?J]B8(B

	;; $B:F=q$-9~$_%G!<%?(B
	not.l	er3		; $B=q9~$_%G!<%?H?E>(B
	and.l	er2, er3	; $B%Y%j%U%!%$%G!<%?$H$NO@M}@Q(B
	not.l	er3		; $B:F=q9~$_%G!<%?(B
	mov.l	er3, @er0	; $B:F=q9~$_%G!<%?J]B8(B

	add.w	#4, r5		; 128Byte$BJ,%k!<%W(B
	cmp.w	#128, r5
	blt	.L30

	bclr	#2, @0xff90:8	; PV bit = 0
	mov.w	#4, r0
	bsr	_asmWaitusec:16
	mov.w	@(-2,er6), r0	; r0 = n
	cmp.w	#6, r0
	bge	.endWriteData

	mov.b	#128, r4l	; $BO"B3E>Aw%P%$%H?t(B
	mov.l	er6, er3	; er6$BBTHr(B
	mov.l	#0xf880, er5	; $BDI2C=q9~$_%G!<%?%"%I%l%9(B
	mov.l	@(-8,er6), er6	; r1 = Flash address
	eepmov.b
	mov.l	er3, er6	; er6$BI|5"(B
	mov.b	#10,r0l		; $B=q9~$_%Q%k%90u2C(B
	bsr	@_writePulse:16
	
.endWriteData:
	pop.l	er0
	pop.l	er1
	pop.l	er5
	pop.l	er4
	add	#12,sp
	pop.l	er6
	rts	

;;;----------------------------------------------------------------------
;;; $B%i%$%H%Q%k%9$N=PNO(B
;;;----------------------------------------------------------------------
	.align 2
	.global _writePulse
_writePulse:
	push.l	er6
	mov.l	er7,er6
	push.l	er4
	push.l	er5

	mov.b	r0l,r5l
	bset.b	#4, @0xff90:8
	mov.w	#100,r4		; 50usec$BBT5!(B
.LOOPA:
	nop			; 2$B%9%F!<%H(B
	sub.w	#1, r4		; 4$B%9%F!<%H(B
	bne	.LOOPA		; 4$B%9%F!<%H(B
	bset	#0, @0xff90:8	

	mov.b	#0,r5h
	shll.w	r5
.LOOPB:
	nop			; 2$B%9%F!<%H(B
	sub.w	#1, r5		; 4$B%9%F!<%H(B
	bne	.LOOPB		; 4$B%9%F!<%H(B
	bclr	#0, @0xff90:8

	mov.w	#10, r4		; 5usec $BBT5!(B
	bsr	_asmWaitusec:16
	bclr	#4, @0xff90:8
	mov.w	#10, r4		; 5usec $BBT5!(B
	bsr	_asmWaitusec:16
	
	pop.l	er5
	pop.l	er4
	pop.l	er6
	rts

;;;----------------------------------------------------------------------
;;; $B%&%'%$%H4X?t(B(1$B<~(B500nsec)
;;;----------------------------------------------------------------------
	.align 2
	.global	_asmWaitusec
_asmWaitusec:
.LOOPW:				; 1usec$BBT5!(B
	nop			; 2$B%9%F!<%H(B
	sub.w	#1, r0		; 4$B%9%F!<%H(B
	bne	.LOOPW		; 4$B%9%F!<%H(B
	rts
	
	.global	_progsyspEnd
_progsyspEnd:	.long	0
	
	.end
